#include "testlib.h"
using namespace std;
typedef long long ll;


const int MAX_N = 500'000;
const int MAX_M = 1'000'000'000;
const int MAX_A = 1'000'000'000;
const int MAX_X = 500'000;


int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int max_n = atoi(argv[1]);
    int n = rnd.next(1, max_n);
    int x = rnd.next(1, n);
    int m = rnd.next(0, MAX_M);

    if (toString(argv[2]) == "rnd") {
        cout << n << ' ' << x << ' ' << m << '\n';
        for (int i = 0; i < n; i++) {
            if (rnd.next(0, (x + 1) / 2)) {
                cout << rnd.next(m, MAX_A);
            } else {
                cout << rnd.next(0, m);
            }
            if (i != n - 1) {
                cout << ' ';
            } else {
                cout << endl;
            }
        }
    } else {
        if (rnd.next(0, 1)) {
            cout << n << ' ' << x << ' ' << m << '\n';
            vector<int> a(n);
            for (int i = 0; i < n; i++) {
                a[i] = rnd.next(0, MAX_A);
            }

            int g = max(0, rnd.next(n - x, n - 1));
            while (g >= 0) {
                a[g] = rnd.next(m, MAX_A);
                g = rnd.next(g - x, g - 1);
            }

            for (int i = 0; i < n; i++) {
                cout << a[i];
                if (i != n - 1) {
                    cout << ' ';
                } else {
                    cout << endl;
                }
            }
        } else {
            x = rnd.next(1, atoi(argv[3]));
            cout << n << ' ' << x << ' ' << m << '\n';
            vector<int> a(n);
            vector<int> p;
            int pred = -x;
            for (int i = 0; i < n; i++) {
                a[i] = rnd.next(0, MAX_A);
                if (a[i] > m && i >= pred + x) {
                    p.push_back(i + 1);
                    pred = i;
                }
                if (p.size() * x > n) {
                    a[i] = rnd.next(0, m);
                }
            }

            for (int i = 0; i < n; i++) {
                cout << a[i];
                if (i != n - 1) {
                    cout << ' ';
                } else {
                    cout << endl;
                }
            }
        }
    }

    return 0;
}
