using namespace std;

#include "testlib.h"

typedef long long ll;

const ll MAX_N = 500'000;
const ll MAX_M = 1'000'000'000;
const ll MAX_A = 1'000'000'000;
const ll MAX_X = 500'000;

int N[] = {MAX_N, 10, MAX_N, MAX_N, 1000, MAX_N};
int X[] = {MAX_X, 10, 1, 2, MAX_X, MAX_X};

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    int g = atoi(validator.group().c_str());
    if (validator.group().empty()) g = 5;
    int n = inf.readInt(1ll, N[g], "n");
    inf.readSpace();
    int x = inf.readInt(1, min(X[g], n), "X");
    inf.readSpace();
    int m = inf.readInt(0, MAX_M,  "M");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
        int a = inf.readInt(0ll, MAX_A, "a_i");
        if (i != n - 1) {
            inf.readSpace();
        }
    }
    inf.readEoln();
    inf.readEof();
    return 0;
}
