using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");

    int cnt = rnd.next(0, 2);

    int n = 1 + rnd.wnext(max_n - 1, 3);
    n = n % 2 == 0 ? n : n + 1;

    int p1 = n, p2 = n;
    if (cnt > 0) {
        p1 = rnd.next(0, n - 1);
    }
    if (cnt > 1) {
        p2 = rnd.next(0, n - 1);
        p2 = p2 >= p1 ? p2 + 1 : p2;
    }

    printf("%d\n", n);
    for (int i = 0; i < n; ++i) {
        printf("%c", i == p1 || i == p2 ? 'b' : 'a');
    }
    printf("\n");
}

