using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>("n");
    int pa = has_opt("a") ? opt<int>("a") : 0;
    int pb = has_opt("b") ? opt<int>("b") : 0;
    char max_c = has_opt("c") ? static_cast<char>('a' + opt<int>("c")) : 'f';

    vector<char> pca(pa);
    vector<char> pcb(pb);
    for (int i = 0; i < pa; ++i) { pca[i] = static_cast<char>(rnd.next('a', max_c)); }
    for (int i = 0; i < pb; ++i) { pcb[i] = static_cast<char>(rnd.next('a', max_c)); }

    printf("%d\n", n);
    for (int i = 0; i < n / 2; ++i) {
        if (pa == 0) {
            printf("%c", rnd.next('a', max_c));
        } else {
            printf("%c", pca[i % pa]);
        }
        if (pb == 0) {
            printf("%c", rnd.next('a', max_c));
        } else {
            printf("%c", pcb[i % pb]);
        }
    }
    printf("\n");
}

