/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

vector<int> pf(string const &s) {
    vector<int> p(s.size());
    p[0] = 0;
    for (int i = 1; i < s.size(); i++) {
        p[i] = p[i - 1];
        while (p[i] > 0 && s[p[i]] != s[i]) {
            p[i] = p[p[i] - 1];
        }
        if (s[p[i]] == s[i]) p[i]++;
    }
    return p;
}

int main() {

    in(int, n)
    in(string, s)
    ll k = n / 2;

    string s0, s1;
    for (int i = 0; i < n; i++) {
        (i % 2 ? s1 : s0).push_back(s[i]);
    }

    int p = n - pf(s).back();
    if (n % p) p = n;

    int p0 = k - pf(s0).back(), p1 = k - pf(s1).back();
    if (k % p0) p0 = k;
    if (k % p1) p1 = k;
    auto pf01 = pf(s0 + '$' + s1 + s1);

    ll m00 = k / p0, m11 = k / p1, md = 0;
    for (int i = k; i < pf01.size(); i++) {
        if (pf01[i] == k) {
            md = m00;
            break;
        }
    }

    ll res = static_cast<ll>(n) * n;
    res -= (m00 + md) * (m11 + md) * p;
    cout << res << '\n';

}