using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>
#include <unordered_set>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

using mhash = tuple<ull, ull, ull>;
//using mhash = tuple<ull, ull, ull, ull, ull>;

const ull P0 = 37;
const ull P1 = 31;
const ull P2 = 41;
const ull M = 1000000007;

mhash mhashmake(ull v) {
//    return make_tuple(get<0>(h) * P0, get<1>(h) * P1, get<2>(h) * P2, get<3>(h) * P3, get<4>(h) * P4);
    return mhash(v, v, v);
//    return mhash(v, v);
}

mhash mhashup(mhash h) {
//    return make_tuple(get<0>(h) * P0, get<1>(h) * P1, get<2>(h) * P2, get<3>(h) * P3, get<4>(h) * P4);
    return make_tuple((get<0>(h) * P0) % M, (get<1>(h) * P1) % M, (get<2>(h) * P2) % M);
//    return make_tuple((get<0>(h) * P0) % M, (get<1>(h) * P1) % M);
}

mhash mhashmul(mhash a, mhash b) {
    return make_tuple(
            (get<0>(a) * get<0>(b)) % M,
            (get<1>(a) * get<1>(b)) % M,
            (get<2>(a) * get<2>(b)) % M);
}

mhash mhashmul(mhash h, ull a) {
    return make_tuple((get<0>(h) * a) % M, (get<1>(h) * a) % M, (get<2>(h) * a) % M);
}

mhash mhashadd(mhash a, mhash b) {
    return make_tuple(
            (get<0>(a) + get<0>(b)) % M,
            (get<1>(a) + get<1>(b)) % M,
            (get<2>(a) + get<2>(b)) % M);
}

mhash mhashsub(mhash a, mhash b) {
    return make_tuple(
            (M + get<0>(a) - get<0>(b)) % M,
            (M + get<1>(a) - get<1>(b)) % M,
            (M + get<2>(a) - get<2>(b)) % M);
}


ull solver() {
    int n;
    cin >> n;
    string ts;
    cin >> ts;
    vector<ull> a(n);
    fori(i, n) { a[i] = ts[i] - 'a' + 1; }

    vector <mhash> Pdeg(n + 1);
    Pdeg[0] = mhashmake(1);
    fori(i, n) { Pdeg[i + 1] = mhashup(Pdeg[i]); }

    vector <mhash> ph0(n / 2);
    vector <mhash> ph1(n / 2);
    ph0[0] = mhashmake(a[0]);
    ph1[0] = mhashmake(a[1]);
    for (int i = 1; i * 2 < n; ++i) {
        ph0[i] = mhashadd(mhashup(ph0[i - 1]), mhashmake(a[i * 2]));
        ph1[i] = mhashadd(mhashup(ph1[i - 1]), mhashmake(a[i * 2 + 1]));
    }

//    for (int i = 0; i < n; ++i) {
//        cout << ((i % 2 == 0) ? get<0>(ph0[i / 2]) : get<0>(ph1[i / 2])) << " ";
//    }
//    cout << "\n";

    vector <pair<mhash, mhash>> hs(n);
    hs[0].X = ph0.back();
    hs[0].Y = ph1.back();
    for (int i = 1; i < n; ++i) {
        //XY......
        //Y......X
        hs[i].X = hs[i - 1].Y;
        if (i == n - 1) {
            hs[i].Y = hs[0].X;
            continue;
        }
        if (i % 2 == 1) {
            int j = i / 2;
//            cout << get<0>(mhashmul(ph0[j], Pdeg[n / 2 - j - 1])) << "\n";
            hs[i].Y = mhashadd(
                    mhashmul(mhashsub(ph0.back(), mhashmul(ph0[j], Pdeg[n / 2 - j - 1])), Pdeg[j + 1]),
                    ph0[j]);
        } else {
            int j = (i - 1) / 2;
            hs[i].Y = mhashadd(
                    mhashmul(mhashsub(ph1.back(), mhashmul(ph1[j], Pdeg[n / 2 - j - 1])), Pdeg[j + 1]),
                    ph1[j]);
        }
//        hs[i].Y = mhashadd(mhashdown(hs[i - 1].X), mhashmul(Pdeg[n / 2 - 1], a[i - 1]));
    }
//    fori(i, n) { cout << get<0>(hs[i].X) << " "; }
//    cout << "\n";
//    fori(i, n) { cout << get<0>(hs[i].Y) << " "; }
//    cout << "\n";

    map<mhash, ull> cnt0, cnt1;
    fori(i, n) {
        if (cnt0.find(hs[i].X) == cnt0.end()) {
            cnt0[hs[i].X] = 0;
        }
        cnt0[hs[i].X] += 1;
        if (cnt1.find(hs[i].Y) == cnt1.end()) {
            cnt1[hs[i].Y] = 0;
        }
        cnt1[hs[i].Y] += 1;
    }

    ull ans = 0;
    set <pair<mhash, mhash>> ac;
    fori(i, n) {
        if (ac.find(make_pair(hs[i].X, hs[i].Y)) != ac.end()) continue;
        ans += cnt0[hs[i].X] * cnt1[hs[i].Y];
        ac.emplace(hs[i].X, hs[i].Y);
    }
    return (ull) n * (ull) n - ans;
}

int main() {
//    fastio;
    cout << solver() << "\n";
}