using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <unordered_map>
#include <unordered_set>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

const ull P0 = 29;
const ull M = 1000000007;

ull solver() {
    int n;
    cin >> n;
    string ts;
    cin >> ts;
    vector<ull> a(n);
    fori(i, n) { a[i] = ts[i] - 'a' + 1; }

    vector<ull> Pdeg(n + 1);
    Pdeg[0] = 1;
    fori(i, n) { Pdeg[i + 1] = (Pdeg[i] * P0) % M; }

    ull ch0 = 0, ch1 = 0;
    for (int i = 0; i * 2 < n; ++i) {
        ch0 = (ch0 + (Pdeg[i] * a[i * 2]) % M) % M;
    }
    for (int i = 0; i * 2 + 1 < n; ++i) {
        ch1 = (ch1 + (Pdeg[i] * a[i * 2 + 1]) % M) % M;
    }

    vector <pair<ull, ull>> hs(n);
    hs[0].X = ch0;
    hs[0].Y = ch1;
    for (int i = 1; i < n; ++i) {
        //XY......
        //Y......X
        hs[i].X = hs[i - 1].Y;
        hs[i].Y = (hs[i - 1].X / P0 + (Pdeg[n / 2 - 1] * a[i - 1]) % M) % M;
    }
//    fori(i, n) { cout << hs[i].X << " "; }
//    cout << "\n";
//    fori(i, n) { cout << hs[i].Y << " "; }
//    cout << "\n";

    unordered_map<ull, ull> cnt0, cnt1;
    fori(i, n) {
        if (cnt0.find(hs[i].X) == cnt0.end()) {
            cnt0[hs[i].X] = 0;
        }
        cnt0[hs[i].X] += 1;
        if (cnt1.find(hs[i].Y) == cnt1.end()) {
            cnt1[hs[i].Y] = 0;
        }
        cnt1[hs[i].Y] += 1;
    }

    ull ans = 0;
    set <pair<ull, ull>> ac;
    fori(i, n) {
        if (ac.find(make_pair(hs[i].X, hs[i].Y)) != ac.end()) continue;
        ans += cnt0[hs[i].X] * cnt1[hs[i].Y];
        ac.emplace(hs[i].X, hs[i].Y);
    }
    return (ull) n * (ull) n - ans;
}

int main() {
//    fastio;
    cout << solver() << "\n";
}