#include "testlib.h"

using namespace std;
const int MAX_FIELD_SIZE = 100000;

// argv:
// . . N_MAX M_MAX K_MAX REEF_PERCENT REEF_LIMIT
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = rnd.next(1, stoi(argv[2]));
    int m = rnd.next(1, min(stoi(argv[3]), MAX_FIELD_SIZE / n));
    int k = rnd.next(1, min(min(n, m), stoi(argv[4])));

    int p = stoi(argv[5]);
    int lim = stoi(argv[6]);
    if (n == 1) {
        if (rnd.next(0, 100) > 10) {
            n = 2;
        }
    }
    cout << n << ' ' << m << ' ' << k << '\n';
    vector<vector<char>> field;
    for (int i = 0; i < n; i++) {
        vector<char> cur (m, '.');
        field.push_back(cur);
    }

    int cur_reefs = 0;
    for (int i = 0; i < n * m; i++) {
        if (rnd.next(0, 100) < p && cur_reefs < lim) {
            int x = rnd.next(0, n - 1);
            int y = rnd.next(0, m - 1);
            field[x][y] = '#';
            ++cur_reefs;
        }
    }

    vector<int> shuffle = rnd.perm(n);
    vector<vector<char>> newfield (n);
    for (int i = 0; i < n; i++) {
        newfield[i] = field[shuffle[i]];
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 && j < k || j == 0 && i < k) {
                cout << '.';
            } else {
                cout << field[i][j];
            }
        }
        cout << '\n';
    }
}