#include "testlib.h"
using namespace std;
typedef long long ll;


const int MAX_N = 200'000;
const int MAX_R = 1'000'000'000;
const int MAX_V = 1'000'000'000;
const int MAX_X = 1'000'000'000;


int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int max_n = atoi(argv[1]);
    int ans = atoi(argv[2]);
    int n = rnd.next(ans, max_n);
    int x = rnd.next(0, MAX_X / ans);
    cout << n << ' ' << x << '\n';
    vector<pair<int, int>> a(n);
    for (int i = 0; i < ans; i++) {
        a[i].first = rnd.next(1, MAX_R);
    }
    sort(a.begin(), a.begin() + ans);
    a[0].second = rnd.next(1, 100);
    for (int i = 1; i < ans; i++) {
        a[i].second = min(MAX_V, a[i - 1].second + x);
    }
    for (int i = ans; i < n; i++) {
        a[i].first = rnd.next(1, MAX_R);
        a[i].second = rnd.next(1, MAX_V);
    }
    int ind = rnd.next(0, ans);
    a[ind].first = rnd.next(1, MAX_R);
    a[ind].second = rnd.next(1, MAX_V);

    shuffle(a.begin(), a.end());

    for (auto i : a) {
        cout << i.first << ' ' << i.second << '\n';
    }
    return 0;
}
