using namespace std;

#include "testlib.h"

typedef long long ll;

const ll MAX_N = 200'000;
const ll MAX_R = 1'000'000'000;
const ll MAX_V = 1'000'000'000;
const ll MAX_X = 1'000'000'000;

int N[] = {MAX_N, 10, MAX_N, MAX_N, MAX_N, 1000, MAX_N};


int main(int argc, char** argv) {
    registerValidation(argc, argv);
    int g = atoi(validator.group().c_str());;
    if (validator.group().empty()) g = 6;
    int n = inf.readInt(1ll, N[g], "n");
    inf.readSpace();
    int x = inf.readInt(0, MAX_X, "X");
    inf.readEoln();
    vector<int> r(n), v(n);
    for (int i = 0; i < n; i++) {
        r[i] = inf.readInt(1ll, MAX_R, "r_i");
        inf.readSpace();
        v[i] = inf.readInt(1ll, MAX_V, "v_i");
        inf.readEoln();
    }
    inf.readEof();

    if (g == 2) {
        ensuref(x == 0 && r == v, "g == 2");
    }
    if (g == 3) {
        ensuref(x == 0, "g == 3");
    }
    if (g == 4) {
        ensuref(*std::max_element(r.begin(), r.end()) == *std::min_element(r.begin(), r.end()), "g = 4");
    }
    return 0;
}
