using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>("n");
    int pa = has_opt("p") ? opt<int>("p") : 0;
    char max_c = has_opt("c") ? static_cast<char>('a' + opt<int>("c")) : 'f';

    vector<char> pca(pa);
    for (int i = 0; i < pa; ++i) { pca[i] = static_cast<char>(rnd.next('a', max_c)); }

    int sh = rnd.next(1, n / 2);
    vector<char> s;
    for (int i = 0; i < n / 2; ++i) {
        if (pa == 0) {
            s.push_back(rnd.next('a', max_c));
        } else {
            s.push_back(pca[i % pa]);
        }
    }

    printf("%d\n", n);
    for (int i = 0; i < n / 2; ++i) {
        printf("%c", s[i]);
        printf("%c", s[(i + sh) % s.size()]);
    }
    printf("\n");
}

